#include "stdafx.h"

#include "ConfigMgr.h"

CConfigMgr::CConfigMgr()
{
	Init();
	LoadCurrentProfile();
}

CConfigMgr::~CConfigMgr()
{
}

void CConfigMgr::Init()
{
	char szFile[MAX_PATH];

	GetConfigFile(szFile);
	strcpy(m_szFile, szFile);
}

void CConfigMgr::LoadCurrentProfile()
{
	FILE *fp = NULL;

	memset(m_data, 1, CONFIG_CONTAINER_SIZE);

	fp = fopen(m_szFile, "r");
	if(fp == NULL) return;
	fread(&m_data, 1, CONFIG_CONTAINER_SIZE, fp);
	fclose(fp);
}

void CConfigMgr::Save()
{
	FILE *fp = NULL;
	fp = fopen(m_szFile, "w+b");
	ASSERT(fp != NULL);
	fwrite(&m_data, 1, CONFIG_CONTAINER_SIZE, fp);
	fclose(fp);
}

void CConfigMgr::SetOption(int nIndex, BOOL bState)
{
	ASSERT(nIndex <= CONFIG_CONTAINER_SIZE - 1);
	ASSERT((bState == TRUE) || (bState == FALSE)); // Only real bool allowed!

	m_data[nIndex] = (unsigned char)bState;
}

BOOL CConfigMgr::GetOption(int nIndex)
{
	ASSERT(nIndex <= CONFIG_CONTAINER_SIZE - 1);
	return (BOOL)m_data[nIndex];
}

void CConfigMgr::GetConfigFile(char *szCfgFile)
{
	LPTSTR lpCommandLine = GetCommandLine();
	char thisPath[MAX_PATH];
	char cfgFile[MAX_PATH];

	GetPathOfFile(thisPath, lpCommandLine);
	strcpy(cfgFile, thisPath + 1); // Pointer math: ignore 1st character, only works with C strings
	strcat(cfgFile, NAME_CONFIGFILE);

	strcpy(szCfgFile, cfgFile);
}

void CConfigMgr::GetPathOfFile(char *szPath, char *szFile)
{
	unsigned long i = 0;

	strcpy(szPath, szFile); // Copy file to path string

	if(strlen(szFile) <= 3) return;

	// Scan for last separator
	for(i = strlen(szFile) - 1; i != 3; i--)
	{
		if(szFile[i] == CHAR_SEPARATOR) break;
	}

	szPath[i+1] = '\0'; // Terminate string
}
