// HashTexts.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "HashCalc.h"
#include "HashTexts.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CHashTexts 


CHashTexts::CHashTexts(CWnd* pParent /*=NULL*/)
	: CDialog(CHashTexts::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHashTexts)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CHashTexts::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHashTexts)
	DDX_Control(pDX, IDC_GET_HASH, m_btHash);
	DDX_Control(pDX, IDC_COPY_TO_CLIP, m_btCopy);
	DDX_Control(pDX, IDC_PASTE, m_btPaste);
	DDX_Control(pDX, IDC_SOURCETEXT, m_sourceWnd);
	DDX_Control(pDX, IDC_RESULTHASHES, m_infoWnd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHashTexts, CDialog)
	//{{AFX_MSG_MAP(CHashTexts)
	ON_BN_CLICKED(IDC_PASTE, OnPaste)
	ON_BN_CLICKED(IDC_COPY_TO_CLIP, OnCopyToClip)
	ON_BN_CLICKED(IDC_GET_HASH, OnGetHash)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CHashTexts 

BOOL CHashTexts::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_sourceWnd.SetBackgroundColor (FALSE, RGB (255, 255, 255));
	m_infoWnd.SetBackgroundColor (FALSE, RGB (255, 255, 255));

	m_richPara.dwMask = PFM_ALIGNMENT | PFM_NUMBERING | PFM_TABSTOPS;
	m_richPara.wNumbering = 0;
	m_richPara.wAlignment = PFA_LEFT;
	m_richPara.cTabCount = 2;
	m_richPara.rgxTabs[0] = 0;
	m_richPara.rgxTabs[1] = 256;
	m_richPara.cbSize = sizeof (PARAFORMAT);
	m_infoWnd.SetParaFormat (m_richPara);

	m_richFormat.cbSize = sizeof (CHARFORMAT);
	m_richFormat.dwMask = CFM_BOLD | CFM_COLOR | CFM_FACE | CFM_ITALIC | CFM_UNDERLINE | CFM_SIZE;
	m_richFormat.dwEffects = 0;
	m_richFormat.crTextColor = RGB (0, 0, 0);
	m_richFormat.bCharSet = ANSI_CHARSET;
	m_richFormat.bPitchAndFamily = /* DEFAULT_PITCH | */ FF_SWISS;
	m_richFormat.yHeight = 8 * 20; // Points to twips
	sprintf (m_richFormat.szFaceName, "Courier");

	CString str; // Empty string bugfix
	str.Empty();
	m_sourceWnd.SetDefaultCharFormat (m_richFormat);
	m_sourceWnd.SetWindowText(str);

	m_infoWnd.SetDefaultCharFormat (m_richFormat);
	m_infoWnd.SetWindowText("Paste the text you want to hash into the editbox\r\nabove and click the 'Hash' button.");

	DragAcceptFiles(TRUE);

	CButtonST *pbt = NULL;
	short i_loop = 0;
	for(i_loop = 0; i_loop < 3; i_loop++)
	{
		// Select button
		if(i_loop == 0) pbt = &m_btHash;
		if(i_loop == 1) pbt = &m_btCopy;
		if(i_loop == 2) pbt = &m_btPaste;

		// Set button properties
		pbt->SetAlign(CButtonST::ST_ALIGN_HORIZ);
		pbt->SetBtnCursor(IDC_HAND);
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_IN, CR_BACK + RGB(16,16,16));
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_OUT, CR_BACK);
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_FOCUS, CR_BACK);
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_IN, RGB(0,0,255));
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_OUT, RGB(0,0,0));
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_FOCUS, RGB(0,0,0));
	}

	m_btHash.SetTooltipText(_T("Hash the text in the editbox above and display the results in the window below."));
	m_btHash.SetBitmaps(IDB_HASH, RGB(255, 0, 255));
	m_btPaste.SetTooltipText(_T("Paste the contents of the clipboard into the editbox above."));
	m_btPaste.SetBitmaps(IDB_PASTE, RGB(255, 0, 255));
	m_btCopy.SetTooltipText(_T("Copy the contents of the results box below to the clipboard."));
	m_btCopy.SetBitmaps(IDB_COPY, RGB(255, 0, 255));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CHashTexts::OnPaste() 
{
	m_sourceWnd.Paste();
}

void CHashTexts::OnCopyToClip() 
{
	long reFirst = 0, reLast = 0;
	long rnFirst = 0, rnLast = 0;

	m_infoWnd.SetFocus();
	m_infoWnd.GetSel(reFirst, reLast);
	m_infoWnd.SetSel(0,-1);
	m_infoWnd.Copy();
	m_infoWnd.SetSel(reFirst, reLast);
}

void CHashTexts::OnGetHash() 
{
	unsigned long j = 0;
	char strHash[256];
	CString strSource = "";
	CString strFinal = "";
	CConfigMgr cfg;
	unsigned char hashBuf[32];
	unsigned long len = 0;

	CString strInfo;
	strInfo = "Hashing... Please wait...";
	m_infoWnd.SetWindowText(strInfo);

	m_sourceWnd.GetWindowText(strSource);
	len = (unsigned long)strSource.GetLength();
	LPTSTR lpSource = strSource.LockBuffer();

	strFinal.Empty();

	CSHA1 sha1;
	MD5_CTX md5;
	unsigned long uCrc32 = 0;
	CMD2 md2;
	MD4_CTX md4;
	CGHash ghash;
	GostHashCtx gost;

	UpdateData(TRUE);

	if(cfg.GetOption(ALG_SHA1) == TRUE)
	{
		strHash[0] = 0;

		sha1.Reset();
		sha1.Update((unsigned char *)lpSource, len);
		sha1.Final();
		sha1.ReportHash(strHash, CSHA1::REPORT_HEX);

		strFinal += "SHA-1      : ";
		strFinal += strHash;
		strFinal += "\r\n";
	}

	if(cfg.GetOption(ALG_MD5) == TRUE)
	{
		MD5Init(&md5, 0);
		MD5Update(&md5, (unsigned char *)lpSource, len);
		MD5Final(&md5);

		sprintf(strHash, "%02X", md5.digest[0]);
		for(j = 1; j < 16; j++)
		{
			if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, md5.digest[j]);
			else sprintf(strHash, "%s %02X", strHash, md5.digest[j]);
		}
		strFinal += "MD5        : ";
		strFinal += strHash;
		strFinal += "\r\n";
	}

	if(cfg.GetOption(ALG_MD4) == TRUE)
	{
		MD4Init(&md4);
		MD4Update(&md4, (unsigned char *)lpSource, len);
		MD4Final(hashBuf, &md4);

		sprintf(strHash, "%02X", hashBuf[0]);
		for(j = 1; j < 16; j++)
		{
			if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
			else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
		}
		strFinal += "MD4        : ";
		strFinal += strHash;
		strFinal += "\r\n";
	}

	if(cfg.GetOption(ALG_MD2) == TRUE)
	{
		md2.Init();
		md2.Update((unsigned char *)lpSource, len);
		md2.TruncatedFinal(hashBuf, 16);

		sprintf(strHash, "%02X", hashBuf[0]);
		for(j = 1; j < 16; j++)
		{
			if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
			else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
		}
		strFinal += "MD2        : ";
		strFinal += strHash;
		strFinal += "\r\n";
	}

	if(cfg.GetOption(ALG_GOST) == TRUE)
	{
		gosthash_init();
		gosthash_reset(&gost);
		gosthash_update(&gost, (const unsigned char *)lpSource, len);

		strHash[0] = 0;
		memset(hashBuf, 0, 32);
		gosthash_final(&gost, hashBuf);
		sprintf(strHash, "%02X", hashBuf[0]);
		for(j = 1; j < 16; j++)
		{
			if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
			else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
		}
		strFinal += "GOST-Hash  : ";
		strFinal += strHash;
		strHash[0] = 0;
		strFinal += "\r\n            ";
		for(j = 16; j < 32; j++)
		{
			if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
			else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
		}
		strFinal += strHash;
		strFinal += "\r\n";	
	}

	if(cfg.GetOption(ALG_CRC32) == TRUE)
	{
		crc32Init(&uCrc32);
		crc32Update(&uCrc32, (unsigned char *)lpSource, len);
		crc32Finish(&uCrc32);

		strHash[0] = 0;
		for(j = 0; j < 4; j++)
		{
			sprintf(strHash, "%s%02X", strHash, (uCrc32 >> (24 - (j * 8))) & 0xFF);
		}
		strFinal += "CRC-32     : ";
		strFinal += strHash;
		strFinal += "\r\n";
	}

	if(cfg.GetOption(ALG_GHASH) == TRUE)
	{
		ghash.Init();
		ghash.Update((unsigned char *)lpSource, len);

		strHash[0] = 0;
		strFinal += "GHash-3    : ";
		ghash.FinalToStr(strHash, 3);
		strFinal += strHash;
		strFinal += "          GHash-5: ";
		strHash[0] = 0;
		ghash.FinalToStr(strHash, 5);
		strFinal += strHash;
		strFinal += "\r\n";
	}

	m_infoWnd.SetWindowText(strFinal);

	strSource.UnlockBuffer();
}
